--- C:/Users/john/AppData/Local/Temp/copy_path.cpp-revBASE.svn000.tmp.cpp	Sun Aug  8 12:14:06 2010
+++ M:/data/boost/branches/release/tools/bcp/copy_path.cpp	Sun Aug  8 12:03:07 2010
@@ -58,7 +58,7 @@
    //
    // do text based copy if requested:
    //
-   if(m_namespace_name.size() && m_lib_names.size() && is_jam_file(p))
+   if(p.leaf() == "Jamroot")
    {
       static std::vector<char> v1, v2;
       v1.clear();
@@ -69,6 +69,32 @@
       static boost::regex libname_matcher;
       if(libname_matcher.empty())
       {
+         libname_matcher.assign("boost_");
+      }
+
+      regex_replace(std::back_inserter(v2), v1.begin(), v1.end(), libname_matcher, m_namespace_name + "_");
+      std::swap(v1, v2);
+      v2.clear();
+
+      std::ofstream os;
+      if(m_unix_lines)
+         os.open((m_dest_path / p).native_file_string().c_str(), std::ios_base::binary | std::ios_base::out);
+      else
+         os.open((m_dest_path / p).native_file_string().c_str(), std::ios_base::out);
+      os.write(&*v1.begin(), v1.size());
+      os.close();
+   }
+   else if(m_namespace_name.size() && m_lib_names.size() && is_jam_file(p))
+   {
+      static std::vector<char> v1, v2;
+      v1.clear();
+      v2.clear();
+      std::ifstream is((m_boost_path / p).native_file_string().c_str());
+      std::copy(std::istreambuf_iterator<char>(is), std::istreambuf_iterator<char>(), std::back_inserter(v1));
+
+      static boost::regex libname_matcher;
+      if(libname_matcher.empty())
+      {
          std::string re = "\\<";
          re += *m_lib_names.begin();
          for(std::set<std::string>::const_iterator i = ++m_lib_names.begin(); i != m_lib_names.end(); ++i)
@@ -106,25 +132,33 @@
 
       static const boost::regex namespace_matcher(
          "(?|"
-            "(namespace\\s+)boost(_\\w+)?"
+            "(namespace\\s+)boost(_\\w+)?(?:(\\s*::\\s*)phoenix)?"
          "|"
             "(namespace\\s+)(adstl|phoenix|rapidxml)\\>"
          "|"
-            "()boost((?:_\\w+)?\\s*(?:::|,|\\)))"
+            "()\\<boost((?:_(?!intrusive_tags)\\w+)?\\s*(?:::))(?:(\\s*)phoenix)?"
          "|"
-            "()((?:adstl|phoenix|rapidxml)\\s*(?:::|,|\\)))"
+            "()\\<((?:adstl|phoenix|rapidxml)\\s*(?:::))"
          "|"
-            "(namespace\\s+\\w+\\s*=\\s*(?:::\\s*)?)boost(_\\w+)?"
+         "(namespace\\s+\\w+\\s*=\\s*(?:::\\s*)?)boost(_\\w+)?(?:(\\s*::\\s*)phoenix)?"
          "|"
-            "(namespace\\s+\\w+\\s*=\\s*(?:::\\s*)?)(adstl|phoenix|rapidxml)\\>"
+            "(namespace\\s+\\w+\\s*=\\s*(?:::\\s*)?(?:\\w+\\s*::\\s*)?)(adstl|phoenix|rapidxml)\\>"
          "|"
-            "(^\\s*#\\s*define[^\\n]+)boost((?:_\\w+)?\\s*)$"
+            "(^\\s*#\\s*define\\s+\\w+\\s+)boost((?:_\\w+)?\\s*)$"
          "|"
             "(^\\s*#\\s*define[^\\n]+)((?:adstl|phoenix|rapidxml)\\s*)$"
+         "|"
+            "()boost(_asio_detail_posix_thread_function|_regex_free_static_mutex)"
+         "|"
+            "()(lw_thread_routine|at_thread_exit|on_process_enter|on_process_exit|on_thread_enter|on_thread_exit|tss_cleanup_implemented)"
+         "|"
+            "(BOOST_CLASS_REQUIRE4?[^;]*)boost((?:_\\w+)?\\s*,)"
+         "|"
+            "(\\(\\s*)boost(\\s*\\))"
          ")"
-         );
+      );
 
-      regex_replace(std::back_inserter(v2), v1.begin(), v1.end(), namespace_matcher, "$1" + m_namespace_name + "$2");
+      regex_replace(std::back_inserter(v2), v1.begin(), v1.end(), namespace_matcher, "$1" + m_namespace_name + "$2(?3$3" + m_namespace_name + "phoenix)", boost::regex_constants::format_all);
       std::swap(v1, v2);
       v2.clear();
 
@@ -171,7 +205,8 @@
          os.open((m_dest_path / p).native_file_string().c_str(), std::ios_base::binary | std::ios_base::out);
       else
          os.open((m_dest_path / p).native_file_string().c_str(), std::ios_base::out);
-      os.write(&*v1.begin(), v1.size());
+      if(v1.size())
+         os.write(&*v1.begin(), v1.size());
       os.close();
    }
    else if(m_unix_lines && !is_binary_file(p))
